## jazz2-native 3.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

# Policies
if(POLICY CMP0127)
	cmake_policy(SET CMP0127 NEW)
endif()
if(POLICY CMP0141)
	cmake_policy(SET CMP0141 NEW)
endif()
if(POLICY CMP0144)
	cmake_policy(SET CMP0144 NEW)
endif()

# Project metadata
set(NCINE_ROOT ${CMAKE_SOURCE_DIR})
set(NCINE_SOURCE_DIR "${NCINE_ROOT}/Sources")
set(NCINE_APP "jazz2")
set(NCINE_APP_NAME "Jazz² Resurrection")
set(NCINE_APP_DESCRIPTION "Open-source reimplementation of Jazz Jackrabbit 2")
set(NCINE_APP_DESCRIPTION_FULL "Jazz² Resurrection is reimplementation of the game Jazz Jackrabbit 2 released in 1998. Supports various versions of the game (Shareware Demo, Holiday Hare '98, The Secret Files and Christmas Chronicles). Also, it partially supports some features of JJ2+ extension and MLLE.\n\nFurther information can be found here: https://deat.tk/jazz2/")
set(NCINE_APP_VENDOR "Dan R.")
set(NCINE_REVERSE_DNS "jazz2.resurrection")
set(NCINE_VERSION "3.3.0")

project(Jazz2
	VERSION "${NCINE_VERSION}"
	DESCRIPTION "${NCINE_APP_NAME}"
	HOMEPAGE_URL "https://deat.tk/jazz2/"
	LANGUAGES CXX C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
get_filename_component(PARENT_SOURCE_DIR ${CMAKE_SOURCE_DIR} DIRECTORY)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

if(NOT CMAKE_GENERATOR_PLATFORM OR "${CMAKE_GENERATOR_PLATFORM}" STREQUAL "${CMAKE_SYSTEM_PROCESSOR}")
	if(EMSCRIPTEN)
		message(STATUS "Compiling for architecture: WASM (on ${CMAKE_SYSTEM_PROCESSOR} machine)")
	elseif(NINTENDO_SWITCH)
		message(STATUS "Compiling for architecture: ${CMAKE_SYSTEM_PROCESSOR} (Nintendo Switch)")
	elseif(APPLE AND CMAKE_OSX_ARCHITECTURES)
		message(STATUS "Compiling for architecture: ${CMAKE_OSX_ARCHITECTURES} (on ${CMAKE_SYSTEM_PROCESSOR} machine)")
	else()
		message(STATUS "Compiling for architecture: ${CMAKE_SYSTEM_PROCESSOR}")
	endif()
else()
	message(STATUS "Compiling for architecture: ${CMAKE_GENERATOR_PLATFORM} (on ${CMAKE_SYSTEM_PROCESSOR} machine)")
endif()

if(APPLE AND CMAKE_OSX_ARCHITECTURES)
	if(CMAKE_OSX_ARCHITECTURES MATCHES "arm64")
		set(NCINE_ARM_PROCESSOR TRUE)
	elseif(CMAKE_OSX_ARCHITECTURES MATCHES "x86_64")
		# Default architecture
	else()
		message(FATAL_ERROR "Architecture \"${CMAKE_OSX_ARCHITECTURES}\" is not supported. Only one architecture (arm64 or x86_64) could be specified at build time.")
	endif()
else()
	string(FIND ${CMAKE_SYSTEM_PROCESSOR} "arm" ARM_SUBSTRING_FOUND)
	string(FIND ${CMAKE_SYSTEM_PROCESSOR} "aarch64" AARCH64_SUBSTRING_FOUND)
	if (ARM_SUBSTRING_FOUND GREATER -1 OR AARCH64_SUBSTRING_FOUND GREATER -1)
		set(NCINE_ARM_PROCESSOR TRUE)
	endif()
endif()
	
include(ncine_options)
include(ncine_get_version)
include(ncine_imported_targets)
include(ncine_imgui)
include(ncine_tracy)

if(NOT IS_DIRECTORY ${NCINE_DATA_DIR})
	message(WARNING "Content directory not found at: ${NCINE_DATA_DIR}")
else()
	message(STATUS "Content directory: ${NCINE_DATA_DIR}")
endif()
	
if(NCINE_BUILD_ANDROID)
	include(ncine_generated_sources)
	include(ncine_build_android)
	return()
endif()

add_executable(${NCINE_APP})

if(WINDOWS_PHONE OR WINDOWS_STORE)
	message(STATUS "Compiling for Windows RT")
else()
	# Falling back to either GLFW or SDL2 if the other one is not available
	if(NOT GLFW_FOUND AND NOT SDL2_FOUND AND NOT Qt5_FOUND)
		message(FATAL_ERROR "No backend between SDL2, GLFW, and QT5 has been found")
	elseif(GLFW_FOUND AND NCINE_PREFERRED_BACKEND STREQUAL "GLFW")
		message(STATUS "Using GLFW as the preferred backend")
	elseif(SDL2_FOUND AND NCINE_PREFERRED_BACKEND STREQUAL "SDL2")
		message(STATUS "Using SDL2 as the preferred backend")
	elseif(Qt5_FOUND AND NCINE_PREFERRED_BACKEND STREQUAL "QT5")
		message(STATUS "Using QT5 as the preferred backend")
	elseif(SDL2_FOUND AND NOT GLFW_FOUND AND NCINE_PREFERRED_BACKEND STREQUAL "GLFW")
		set(NCINE_PREFERRED_BACKEND "SDL2")
		message(WARNING "Using SDL2 as backend because GLFW cannot be found")
	elseif(GLFW_FOUND AND NOT SDL2_FOUND AND NCINE_PREFERRED_BACKEND STREQUAL "SDL2")
		set(NCINE_PREFERRED_BACKEND "GLFW")
		message(WARNING "Using GLFW as backend because SDL2 cannot be found")
	endif()
endif()

include(ncine_compiler_options)
include(ncine_headers)
include(ncine_sources)
include(ncine_extra_sources)
include(ncine_generated_sources)

# Organize main project files into folders
ncine_assign_source_group(PATH_PREFIX ${NCINE_SOURCE_DIR} FILES ${HEADERS} ${SOURCES})
foreach(SOURCE_FILE IN LISTS SHADER_FILES)
	source_group("Shaders" FILES ${SOURCE_FILE})
endforeach()
foreach(SOURCE_FILE ${GENERATED_SOURCES})
	source_group("Generated Files" FILES ${SOURCE_FILE})
endforeach()

target_sources(${NCINE_APP} PRIVATE ${SOURCES} ${HEADERS} ${SHADER_FILES} ${GENERATED_SOURCES})

# Windows RT uses custom packaging, enable it only for other platforms
if(NOT WINDOWS_PHONE AND NOT WINDOWS_STORE AND NOT ANDROID AND NOT NCINE_BUILD_ANDROID AND NOT NINTENDO_SWITCH)
	include(ncine_installation)
endif()
include(ncine_strip_binaries)

=== debian/changelog ===
jazz2-native (3.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1088176)

 -- Antoine Le Gonidec <vv221@debian.org>  Mon, 02 Feb 2026 14:37:18 +0100

## jazz2-native 3.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,19 @@
 	cmake_policy(SET CMP0144 NEW)
 endif()
 
+if(NOT CMAKE_CONFIGURATION_TYPES)
+	get_property(_haveMultiConfigGenerator GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
+	if(_haveMultiConfigGenerator)
+		set(CMAKE_CONFIGURATION_TYPES "Debug;Release")
+	endif()
+endif()
+if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+	set(_defaultBuildtype "Debug")
+	message(STATUS "Setting build configuration to \"${_defaultBuildtype}\" as none was specified")
+	set(CMAKE_BUILD_TYPE "${_defaultBuildtype}" CACHE STRING "Build configuration" FORCE)
+	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
+endif()
+
 # Project metadata
 set(NCINE_ROOT ${CMAKE_SOURCE_DIR})
 set(NCINE_SOURCE_DIR "${NCINE_ROOT}/Sources")
@@ -20,7 +33,7 @@
 set(NCINE_APP_DESCRIPTION_FULL "Jazz² Resurrection is reimplementation of the game Jazz Jackrabbit 2 released in 1998. Supports various versions of the game (Shareware Demo, Holiday Hare '98, The Secret Files and Christmas Chronicles). Also, it partially supports some features of JJ2+ extension and MLLE.\n\nFurther information can be found here: https://deat.tk/jazz2/")
 set(NCINE_APP_VENDOR "Dan R.")
 set(NCINE_REVERSE_DNS "jazz2.resurrection")
-set(NCINE_VERSION "3.3.0")
+set(NCINE_VERSION "3.5.0")
 
 project(Jazz2
 	VERSION "${NCINE_VERSION}"
@@ -29,7 +42,6 @@
 	LANGUAGES CXX C)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
-get_filename_component(PARENT_SOURCE_DIR ${CMAKE_SOURCE_DIR} DIRECTORY)
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 
 if(NOT CMAKE_GENERATOR_PLATFORM OR "${CMAKE_GENERATOR_PLATFORM}" STREQUAL "${CMAKE_SYSTEM_PROCESSOR}")
@@ -68,10 +80,10 @@
 include(ncine_imgui)
 include(ncine_tracy)
 
-if(NOT IS_DIRECTORY ${NCINE_DATA_DIR})
-	message(WARNING "Content directory not found at: ${NCINE_DATA_DIR}")
+if(NOT IS_DIRECTORY ${NCINE_CONTENT_DIR})
+	message(WARNING "Content directory not found at: ${NCINE_CONTENT_DIR}")
 else()
-	message(STATUS "Content directory: ${NCINE_DATA_DIR}")
+	message(STATUS "Content directory: ${NCINE_CONTENT_DIR}")
 endif()
 	
 if(NCINE_BUILD_ANDROID)

=== Sources/nCine/Backends/Android/Bridge/app/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(nCine-Android-${ANDROID_ABI})

# Check if we can use IFUNC for CPU dispatch. This part is already in `ncine_options.cmake`, but we need to check it also against Android NDK toolchain.
if(DEATH_CPU_USE_RUNTIME_DISPATCH)
	include(CheckCXXSourceCompiles)
	set(CMAKE_REQUIRED_QUIET ON)
	check_cxx_source_compiles("\
int fooImplementation() { return 42; }
#if defined(__ANDROID_API__) && __ANDROID_API__ < 30
#error need Android API 30+ to have AT_HWCAP passed into the resolver
#endif
extern \"C\" int(*fooDispatcher())() {
	return fooImplementation;
}
int foo() __attribute__((ifunc(\"fooDispatcher\")));
int main() { return foo() - 42; }\
		" _DEATH_CPU_CAN_USE_IFUNC)
	set(CMAKE_REQUIRED_QUIET OFF)
	if(_DEATH_CPU_CAN_USE_IFUNC)
		# DEATH_CPU_USE_RUNTIME_DISPATCH is already enabled
		set(DEATH_CPU_USE_IFUNC ON)
	else()
		set(DEATH_CPU_USE_RUNTIME_DISPATCH OFF)
		message(STATUS "GNU IFUNC is not supported on Android ${ANDROID_PLATFORM}")
	endif()
endif()

set(NCINE_SOURCE_DIR "${NCINE_ROOT}/Sources/")

include(ncine_imported_targets)

if(NCINE_DYNAMIC_LIBRARY)
	add_library(${NCINE_APP} SHARED)
else()
	add_library(${NCINE_APP} STATIC)
endif()
add_library(ncine_main STATIC main.cpp)
add_library(jnicall_functions STATIC jnicall_functions.cpp)

target_link_libraries(${NCINE_APP} PRIVATE ${ANDROID_LIBRARY} ${EGL_LIBRARY} ${GLES3_LIBRARY} ${LOG_LIBRARY})
if(ANDROID_PLATFORM GREATER_EQUAL 30)
	target_link_libraries(${NCINE_APP} PRIVATE ${NATIVEWINDOW_LIBRARY})
endif()
target_link_libraries(ncine_main PRIVATE ${NCINE_APP})

include(ncine_compiler_options)

include(ncine_headers)
include(ncine_sources)
include(ncine_extra_sources)

# Convert strings back to the original lists
string(REPLACE " " ";" GENERATED_SOURCES "${GENERATED_SOURCES}")
string(REPLACE " " ";" ANDROID_GENERATED_FLAGS "${ANDROID_GENERATED_FLAGS}")

target_sources(${NCINE_APP} PRIVATE ${SOURCES} ${HEADERS} ${SHADER_FILES} ${GENERATED_SOURCES})

target_include_directories(${NCINE_APP} PRIVATE ${NCINE_SOURCE_DIR}/Shared)
target_include_directories(ncine_main PRIVATE ${NCINE_SOURCE_DIR} ${NCINE_SOURCE_DIR}/Shared)
if(IS_DIRECTORY ${GENERATED_INCLUDE_DIR})
	target_include_directories(${NCINE_APP} PRIVATE ${GENERATED_INCLUDE_DIR})
	# Internal sources can access a generated header with or without the parent directory
	get_filename_component(PARENT_GENERATED_INCLUDE_DIR ${GENERATED_INCLUDE_DIR} DIRECTORY)
	target_include_directories(${NCINE_APP} PRIVATE ${PARENT_GENERATED_INCLUDE_DIR})
	target_include_directories(ncine_main PRIVATE ${PARENT_GENERATED_INCLUDE_DIR})
endif()

target_include_directories(${NCINE_APP} PRIVATE ${CMAKE_ANDROID_NDK}/sources/android/native_app_glue)
target_include_directories(ncine_main PRIVATE ${CMAKE_ANDROID_NDK}/sources/android/native_app_glue)
if(NCINE_WITH_TRACY)
	target_include_directories(${NCINE_APP}
		PUBLIC $<BUILD_INTERFACE:${TRACY_INCLUDE_ONLY_DIR}/tracy>
		PUBLIC $<INSTALL_INTERFACE:include/tracy>)
endif()

target_compile_definitions(${NCINE_APP} PRIVATE ${ANDROID_GENERATED_FLAGS})
target_link_libraries(${NCINE_APP} PRIVATE ${PRIVATE_LINK_LIBRARIES})

# Merged "native_app_glue" into "game" target
add_library(game SHARED ${ANDROID_NDK}/sources/android/native_app_glue/android_native_app_glue.c)
set(JNICALL_FUNCTIONS_LINKER_OPTIONS -Wl,--whole-archive jnicall_functions -Wl,--no-whole-archive)
target_link_libraries(game PRIVATE ${ANDROID_LIBRARY} ${LOG_LIBRARY} ${JNICALL_FUNCTIONS_LINKER_OPTIONS} ncine_main ${NCINE_APP})
target_include_directories(game PRIVATE ${ANDROID_NDK}/sources/android/native_app_glue)
#if(NOT NCINE_DYNAMIC_LIBRARY)
#	target_include_directories(game PRIVATE ${NCINE_ROOT}/include/ncine)
#endif()
target_compile_definitions(game PRIVATE ${ANDROID_GENERATED_FLAGS})

# Export ANativeActivity_onCreate() - https://github.com/android-ndk/ndk/issues/381
set_property(TARGET game APPEND_STRING PROPERTY LINK_FLAGS "-u ANativeActivity_onCreate")

include(ncine_strip_binaries)

=== debian/changelog ===
jazz2-native (3.5.0-2) unstable; urgency=medium

  [ Sébastien Noel ]
  * Fix patch to game data files install path.
    (Closes: #1127159)

 -- Antoine Le Gonidec <vv221@debian.org>  Fri, 06 Feb 2026 20:24:47 +0100

jazz2-native (3.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Antoine Le Gonidec <vv221@debian.org>  Thu, 05 Feb 2026 21:28:16 +0100

=== debian/control ===
Source: jazz2-native
Section: contrib/games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Antoine Le Gonidec <vv221@debian.org>,
Homepage: https://deat.tk/jazz2/
Vcs-Browser: https://git.vv221.fr/debian/jazz2-native/
Vcs-Git: https://git.vv221.fr/debian/jazz2-native.git
Standards-Version: 4.7.3
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libcurl4-openssl-dev,
 libopenal-dev,
 libopenmpt-dev,
 libsdl2-dev,
 zlib1g-dev

Package: jazz2-native
Architecture: any
Depends:
 jazz2-native-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: jazz-jackrabbit-2 | play.it-vv221
Description: Re-implementation of the Jazz Jackrabbit 2 engine
 Jazz² Resurrection is a re-implementation of the game Jazz Jackrabbit 2
 released in 1998. It supports various versions of the game (Shareware Demo,
 Holiday Hare '98, The Secret Files and Christmas Chronicles).
 Also, it partially supports some features of JJ2+ extension and MLLE.
 .
 Jazz² Resurrection supports various versions of the original game,
 but it is recommended to use The Secret Files.
 .
 In addition to this engine, non-free game data files must be provided.
 These data files can be packaged using a tool like ./play.it,
 shipped in the Debian repositories.

Package: jazz2-native-data
Architecture: all
Depends: ${misc:Depends}
Description: Re-implementation of the Jazz Jackrabbit 2 engine (data files)
 Jazz² Resurrection is a re-implementation of the game Jazz Jackrabbit 2
 released in 1998. It supports various versions of the game (Shareware Demo,
 Holiday Hare '98, The Secret Files and Christmas Chronicles).
 Also, it partially supports some features of JJ2+ extension and MLLE.
 .
 This package provides engine data files that are not specific to the host
 architecture. These are not the game data files, that still need to be
 provided in addition to this package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DNCINE_DOWNLOAD_DEPENDENCIES=OFF -DNCINE_PREFERRED_BACKEND=SDL2 -DNCINE_VERSION_FROM_GIT=OFF -DNCINE_LINUX_PACKAGE=jazz2-native

=== debian/watch ===
Version: 5

Template: Github
Owner: deathkiller
Project: jazz2-native
